#include<stdio.h>
#include<stdlib.h>
#include <iostream>
#include <cstdlib>
#include <time.h>
#include <math.h>

void main()
{
int curindex,id,tempindex,maxindex,constdensity,partials,reverb,k;
float j,mingraindur, dur, gphase, start, temp,i,streams,rang,initrang,iduration;
float midpointrang1, midpointcount1,midpointrang2, midpointcount2,midpointrang3, midpointcount3;
float a[20000],e[20000],d[20000],igstart,igmid1, igmid2, igmid3, igend,timecount;
float index,aval,eval,dval,avalold,evalold,dvalold,offset,gdur,freq,fundamental;
char filenameA[25],filenameE[25],filenameD[25];

FILE *ofp;
FILE *ifpa;
FILE *ifpe;
FILE *ifpd;

/******************** WELCOME TEXT *********************************************************/
printf("This program produces a score file for the Csound instrument, \nAmbiBoidadditive.orc\n\n");
printf("Please ensure the coordinates files are stored in the default \nfolder, D:\\Boids\n\n\n");

printf("Grainlet synthesis linkss the grain duration to the frequency of \nthe source signal.\n");
printf("In this additive synthesis approach, each grain stream also \ncorresponds to a single partial\n");
printf("Hence, the source signal for each grain stream is a sine tone\n");
printf("at integer multiples of a specifiec fundamental frequency.\n");
printf("In addition, each grain stream is spatialized using the MAX MSP \nimplementation of Boids\n");
/********************* OBTAIN USER DATA ****************************************************/ 

printf("\n\nPlease enter the fundamenal frequency in Hertz. Eg. 100\n");
scanf("%f", &fundamental);

printf("\n\nPlease enter the number of harmonics in the source signal\n");
printf("1 = a single sine wave per grain stream, 3 = 3 sine waves at harmonic intervals\n");
scanf("%d", &partials);

printf("Please enter the total duration in seconds\n");
scanf("%f", &dur);

printf("The intergrain duration is specified as multiples of the grain duration\n");
printf("This controls the density, 0 produces the densest possible tone,\n");
printf("1 introduces one grain of silence between each grain, etc.\n\n");
printf("Type 1 for a constant density or 0 to specify a dynamic density control\n");
scanf("%d", &constdensity);
if(constdensity ==0)
{
	printf("Enter the initial intergrain value\n");
	scanf("%f", &igstart);
	printf("Enter the intergrain value at a 1/4 of the total duration.\n");
	scanf("%f", &igmid1);
	printf("Enter the intergrain value at the 1/2 of the total duration.\n");
	scanf("%f", &igmid2);
	printf("Enter the intergrain value at the 3/4 of the total duration.\n");
	scanf("%f", &igmid3);
	printf("Enter the intergrain value at the end of the file.\n");
	scanf("%f", &igend);
}
else
{
	printf("Enter the intergrain value\n");
	scanf("%f", &igstart);
}

printf("Please enter the total no of grain streams\n");
printf("\tThis corresponds to the number of partials.\n"); 
scanf("%f", &streams);
mingraindur=fundamental*(1/(streams*fundamental));    //min grain durarion = boids spatial sampling period
printf("\nThe minimum grain duration will be %f\n", mingraindur);
printf("Ensure that this equals the spatial sampling interval in MAX MSP.\n\n\n");
printf("Type 1 to turn on global reverb, type 0 to turn it off\n");
scanf("%d", &reverb);



/********* CREATE FILE AND WRITE GEN ROUTINES **********************************************/
ofp = fopen("AMBIBOIDadditive.sco", "w");  //write user data as comment in score file..
fprintf(ofp, ";User data - fundamental %f, igstart %f, igmid1 %f, igmid1 %f, igmid1 %f, igend %f, duration %f, streams %f mingrain duration %f\n", fundamental, igstart, igmid1, igmid2, igmid3, igend, dur, streams, mingraindur);
fprintf(ofp, ";Table 1 6 simple sine wave harmonics (using GEN10).\n");
fprintf(ofp, "f1 0 16384 10 ");
for(k=0;k<partials;k++)
{
  fprintf(ofp, "1 ");
}
fprintf(ofp, "\nf2 0 16385 20 7 1 2    ; grain envelope\n");
fprintf(ofp, "\n;inst\t srt\t\t  dur\t\t voice Phase\t Aziold\t Azi\t\t Elevold\t Elev\t\t Distold\t Dist\t\t Graindur\t Fundamental\n");

for(i=1;i<=streams;i++) //loop through each grain stream
{
id=int(i);
printf("writing voice %d ",id); 
sprintf(filenameA, "D:\\Max\\bg\\bg%da.txt", id);   //create paths and filenames for this stream
sprintf(filenameE, "D:\\Max\\bg\\bg%de.txt", id);
sprintf(filenameD, "D:\\Max\\bg\\bg%dd.txt", id);

ifpa=fopen(filenameA, "r");
ifpe=fopen(filenameE, "r");
ifpd=fopen(filenameD, "r");

if ((ifpa==0) || (ifpe ==0) || (ifpd==0))
{
	printf("Program quitting due to missing Boids input files!\n"); 
	printf("Please ensure the coordinates files are stored in the default \nfolder, D:\\Boids\n\n\n");
	break;
}

 for(curindex=0;curindex<20000;curindex++)
 {  // read all the spatal values for this stream into 3 arrays)
  fscanf(ifpa, "%f", &a[curindex]);
  fscanf(ifpe, "%f", &e[curindex]);
  fscanf(ifpd, "%f", &d[curindex]); 
  if (feof(ifpd))    /* check End of File flag */
    {
		maxindex=curindex;    
		break; 
	}
 }

index=0;
curindex=0.0;
timecount=0;

temp=rand();
gphase=temp/32767.0;		   //create a random number between 0 and 1
freq=i*fundamental;			   //calculate the harmonic for this stream
gdur = fundamental*(1/freq);   //calculate the assoicated grain duration
printf("partial no.%f freq %f grain duration %f\n", i, freq, gdur);
rang = gdur+(igstart*gdur);	   //calulate total grain duration
initrang = gdur+(igstart*gdur);
for(j=0.0;j<dur;j=j+rang)	   //each grain	corresponds to a single I statement in the score
 {
  curindex=index;			   //interpolation between regularly sampled spatial co-ordinates
  tempindex=curindex+1;		
  offset=index-curindex;	   	
  if(curindex>=maxindex)
	{
		printf("\n\nEnd of Boids input file reached\n\n");
		printf("Score file will contain unstable values\n\n");
		printf("Please either increase the minimum grain duration, or\n");
		printf("resample Boids in MAX MSP at a faster sampling period\n");
		break;
	}

 aval = (((a[tempindex])-(a[curindex])) * (offset)) + a[curindex]; //interpolate
 eval = (((e[tempindex])-(e[curindex])) * (offset)) + e[curindex]; //interpolate
 dval = (((d[tempindex])-(d[curindex])) * (offset)) + d[curindex]; //interpolate
 aval=aval+360.0;				//ensure azimuth always positive.
 if(j==0)
	{//if reading the very first value then set old value equal to current
	avalold=aval;
	evalold=eval;
	dvalold=dval;
	}
 
 start=j+(gphase/2);				//randomise start time for each grain stream
 iduration = rang*2;				//leave time at the end of each I statement for delay, reflections, etc..
 if(aval<0.0) {aval=aval+360.0;}
 if(aval>360.0) {aval=aval-360.0;}	//keeps azimuth in the range 0-360
 fprintf(ofp, "i1\t %f\t %f\t %d\t %f\t %f\t %f\t %f\t %f\t %f\t %f\t %f\t %f\n", start, iduration, id, gphase, avalold, aval, evalold, eval, dvalold,dval,gdur,freq);
 index=index+(rang/mingraindur);	//increase index by multiples of minimum grain duration.
 avalold=aval;						//store old value for next pass
 evalold=eval;
 dvalold=dval;
									//dynamic density control
 timecount=timecount+rang;			//count the time elapsed
 if((timecount<=(dur/4)) && (constdensity==0))  //for start to mid point
	{ rang = initrang+(gdur*((timecount/(dur/4))*(igmid1-igstart)));   //alter rang (=grain duration + gap)
	  midpointrang1=rang;			//store range at midpoint								
	  midpointcount1=timecount;		//store midpoint
	}
 if((timecount>(dur/4)) && (timecount<=(dur/2)) && (constdensity==0))  //for start to mid point
	{ rang = midpointrang1+(gdur*(((timecount-midpointcount1)/(dur/4))*(igmid2-igmid1)));   //alter rang (=grain duration + gap)
	  midpointrang2=rang;			//store range at midpoint								
	  midpointcount2=timecount;		//store midpoint
	}
 if((timecount>(dur/2)) && (timecount<=((dur*3)/4)) && (constdensity==0))  //for start to mid point
	{ rang = midpointrang2+(gdur*(((timecount-midpointcount2)/(dur/4))*(igmid3-igmid2)));   //alter rang (=grain duration + gap)
	  midpointrang3=rang;			//store range at midpoint								
	  midpointcount3=timecount;		//store midpoint
	}
 if((timecount>((dur*3)/4))&&(constdensity==0))		//for mid to end point
	{ rang = (midpointrang3)+(gdur*(((timecount-midpointcount3)/(dur/4))*(igend-igmid3)));}  //alter range
 
}
 
fclose(ifpa);  
fclose(ifpe);  
fclose(ifpd);  
}
if(reverb==1)
{
 fprintf(ofp, "\ni99\t 0\t %f\t\n",dur);	//write I statement for global reverb instrument 99
}
fprintf(ofp, "\ne\n");

fclose(ofp);     

printf("\n\n\t\bScore file created and written to AmbiBoidadditive.sco\n\n");
}
